package org.vigia.client.driver;

/**
 * Coordinates that represent the position of the Wiimote with respect to the infrared leds.
 * @author  Ada
 */
public class Coordinates {
	
	/**
	 * X coordinate
	 */
	private int x;
	
	/**
	 * Y coordinate
	 */
	private int y;
	
	/**
	 * Z coordinate (distance from the infrared leds)
	 */
	private float z;
	
	/**
	 * Constructor.
	 * @param x X coordinate.
	 * @param y Y coordinate.
	 * @param z Z coordinate.
	 */
	public Coordinates(int x, int y, float z){
		this.x = x;
		this.z = z;
		this.y = y;
	}
	
	/**
	 * Gets the x coordinate.
	 * @return  the x coordinate.
	 */
	public int getX(){
		return x;
	}
	
	
	/**
	 * Gets the y coordinate.
	 * @return  the y coordinate.
	 */
	public int getY(){
		return y;
	}
	
	
	/**
	 * Gets the z coordinate.
	 * @return  the z coordinate.
	 */
	public float getZ(){
		return z;
	}
	
	/**
	 * Sets the x coordinate.
	 * @param x the new coordinate x.
	 */
	public void setX(int x) {
		this.x = x;
	}
	
	/**
	 * Sets the y coordinate.
	 * @param y the new coordinate y.
	 */
	public void setY(int y) {
		this.y = y;
	}
	
	/**
	 * Sets the z coordinate.
	 * @param z the new z coordinate.
	 */
	public void setZ(float z) {
		this.z = z;
	}
}
