
package org.vigia.client.gui.view;

import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;

/**
 * Dialog for specify ip of server.
 * @author Daniel Hector Stolfi Rosso
 * @version 1.0 (25/11/08)
 */
@SuppressWarnings("serial")
public class Connect extends JDialog {

	/**
	 * ip_panel: panel for IP address
	 */
	private Ip ip_panel;

	/**
	 * Constructor for Connect Dialog
	 * @param owner JFrame Parent
	 * @param def_IP1 First byte of IP address
	 * @param def_IP2 Second byte of IP address
	 * @param def_IP3 Third byte of IP address
	 * @param def_IP4 Fourth byte of IP address
	 * @param ctr ActionListener in controller
	 * @param ActCmdOk Constant for action of button Ok
	 * @param ActCmdCancel Constant for action of button Cancel
	 * @param ActCmdAdvOpc Constant for action of button Advanced Options
	 */
	public Connect(JFrame owner, int def_IP1, int def_IP2, int def_IP3, int def_IP4, ActionListener ctr, String ActCmdOk, String ActCmdCancel, String ActCmdAdvOpc) {
		super(owner,"Conectar a un servidor");
		setSize(270, 160);
		setLayout(null);
        setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
        setLocationRelativeTo(owner);                
        setModal(true);
        setResizable(false);
      
        // Panel IP
        ip_panel = new Ip();
        add(ip_panel);
        ip_panel.setLocation(0, 10);        
        ip_panel.setValues(def_IP1,def_IP2,def_IP3,def_IP4);
        
		// Button Opc. Avanzadas
		JButton jB_AvOp = new JButton("Opciones Avanzadas");
		jB_AvOp.addActionListener(ctr);
		jB_AvOp.setActionCommand(ActCmdAdvOpc);		
		add(jB_AvOp);
		jB_AvOp.setBounds(10, 55, 245, 30);

		// Button Cancel
		JButton jB_Can = new JButton("Cancelar");
		jB_Can.addActionListener(ctr);
		jB_Can.setActionCommand(ActCmdCancel);
		add(jB_Can);
		jB_Can.setBounds(155, 95, 100, 30);
		
		// Button Connect
		JButton jB_Con = new JButton("Conectar");
		jB_Con.addActionListener(ctr);
		jB_Con.setActionCommand(ActCmdOk);
		add(jB_Con);
		jB_Con.setBounds(45, 95, 100, 30);
				
	}
	
	/**
	 * Gets the first IP byte
	 * @return The first IP byte
	 */
	public int getIP1() {
		return ip_panel.getIP1();
	}
	
	/**
	 * Gets the second IP byte
	 * @return The second IP byte
	 */
	public int getIP2() {
		return ip_panel.getIP2();
	}

	/**
	 * Gets the third IP byte
	 * @return The third IP byte
	 */
	public int getIP3() {
		return ip_panel.getIP3();
	}

	/**
	 * Gets the fourth IP byte
	 * @return The fourth IP byte
	 */
	public int getIP4() {
		return ip_panel.getIP4();
	}
	
	/**
	 * Sets the IP value
	 * @param ip1 The first IP byte
	 * @param ip2 The second IP byte
	 * @param ip3 The third IP byte
	 * @param ip4 The fourth IP byte
	 */
	public void setIP(int ip1, int ip2, int ip3, int ip4) {
		ip_panel.setValues(ip1, ip2, ip3, ip4);
	}

}
