
package org.vigia.client.gui.view;

import java.awt.Graphics;
import java.awt.image.BufferedImage;

import javax.swing.JPanel;

/**
 * Panel for show the image
 * @author Daniel Hector Stolfi Rosso
 * @version 1.0 (25/11/08)
 */
@SuppressWarnings("serial")
public class ImagePanel extends JPanel {
	
	/**
	 * bImg: BufferedImage for panel 
	 */
	private BufferedImage bImg = null;
	
	/**
	 * Constructor for the Image Panel
	 * @param isDobleBuffered Create double buffered panel
	 */
	public ImagePanel(boolean isDobleBuffered) {
		super(isDobleBuffered);
	}
	
	/**
	 * Sets the image
	 * @param bImg The image to shows 
	 */
	public void setImage(BufferedImage bImg) {
		this.bImg = bImg;
	}
	
	/**
	 * Paints the image
	 * @param g Graphics context 
	 */
	public void paint(Graphics g) {
		g.drawImage(bImg, 80, 25, this);
	}

	/**
	 * Gets the image
	 * @return The current image in the panel
	 */
	public BufferedImage getImage() {
		return bImg;
	}
}
