
package org.vigia.client.gui.view;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.text.NumberFormat;

import javax.swing.JFormattedTextField;
import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 * Panel for IP
 * @author Daniel Hector Stolfi Rosso
 * @version 1.0 (25/11/08)
 */
@SuppressWarnings("serial")
public class Ip extends JPanel implements PropertyChangeListener  {

	/**
	 * jFTP_IP1: First Byte of IP Address
	 */
	private JFormattedTextField jFTF_IP1;
	/**
	 * jFTP_IP2: Second Byte of IP Address
	 */
	private JFormattedTextField jFTF_IP2;
	/**
	 * jFTP_IP3: Third Byte of IP Address
	 */
	private JFormattedTextField jFTF_IP3;
	/**
	 * jFTP_IP4: Fourth Byte of IP Address
	 */
	private JFormattedTextField jFTF_IP4;
	/**
	 * def_ip1: First number of IP Address
	 */	
	private int def_ip1;
	/**
	 * def_ip2: Second number of IP Address
	 */	
	private int def_ip2;
	/**
	 * def_ip3: Third number of IP Address
	 */	
	private int def_ip3;
	/**
	 * def_ip4: Fourth number of IP Address
	 */	
	private int def_ip4;

	/**
	 * Constructor for Panel Ip
	 */	
	public Ip () {
		setSize(260,30);
		setLayout(null);
		setBorder(null);
        // label
        JLabel jL = new JLabel("Direccin IP");
        add(jL);
        jL.setBounds(10, 5, 100, 20);
        
 		// formattedtextfield        

    	jFTF_IP1 = new JFormattedTextField(NumberFormat.getIntegerInstance());
    	jFTF_IP1.addPropertyChangeListener("value", this);
        add(jFTF_IP1);
        jFTF_IP1.setBounds(120, 5, 30, 20);
        // IP2
    	jFTF_IP2 = new JFormattedTextField(NumberFormat.getIntegerInstance());
    	jFTF_IP2.addPropertyChangeListener("value", this);
        add(jFTF_IP2);
        jFTF_IP2.setBounds(155, 5, 30, 20);
        // IP3
    	jFTF_IP3 = new JFormattedTextField(NumberFormat.getIntegerInstance());
    	jFTF_IP3.addPropertyChangeListener("value", this);
        add(jFTF_IP3);
        jFTF_IP3.setBounds(190, 5, 30, 20);
        // IP4
    	jFTF_IP4 = new JFormattedTextField(NumberFormat.getIntegerInstance());
    	jFTF_IP4.addPropertyChangeListener("value", this);
        add(jFTF_IP4);
        jFTF_IP4.setBounds(225, 5, 30, 20);
        
        setValues(0,0,0,0);
	}
	
	/**
	 * Sets the values for the fields
	 * @param def_IP1 First byte of IP address
	 * @param def_IP2 Second byte of IP address
	 * @param def_IP3 Third byte of IP address
	 * @param def_IP4 Fourth byte of IP address
	 */
	public void setValues(int def_IP1, int def_IP2, int def_IP3, int def_IP4) {
		def_ip1 = def_IP1;
		def_ip2 = def_IP2;
		def_ip3 = def_IP3;
		def_ip4 = def_IP4;
		jFTF_IP1.setValue(def_ip1);
		jFTF_IP2.setValue(def_ip2);
		jFTF_IP3.setValue(def_ip3);
		jFTF_IP4.setValue(def_ip4);
	}
	
	/**
	 * Validates ip fields
	 * @param evt field to validate
	 */
	public void propertyChange(PropertyChangeEvent evt) {
        JFormattedTextField source = (JFormattedTextField)evt.getSource();
        int num = ((Number)source.getValue()).intValue();
        if ((source == jFTF_IP1) && ((num <= 0) || (num >= 255))) source.setValue(def_ip1);
        else if ((source == jFTF_IP2) && ((num < 0) || (num >= 255))) source.setValue(def_ip2);
        else if ((source == jFTF_IP3) && ((num < 0) || (num >= 255))) source.setValue(def_ip3);   
        else if ((source == jFTF_IP4) && ((num <= 0) || (num >= 255))) source.setValue(def_ip4);   
	}
	
	/**
	 * Gets IP1 value
	 * @return IP1 value
	 */
	public int getIP1() {
		return ((Number)jFTF_IP1.getValue()).intValue();
	}
	
	/**
	 * Gets IP2 value
	 * @return IP2 value
	 */
	public int getIP2() {
		return ((Number)jFTF_IP2.getValue()).intValue();
	}

	/**
	 * Gets IP3 value
	 * @return IP3 value
	 */
	public int getIP3() {
		return ((Number)jFTF_IP3.getValue()).intValue();
	}
	
	/**
	 * Gets IP4 value
	 * @return IP4 value
	 */
	public int getIP4() {
		return ((Number)jFTF_IP4.getValue()).intValue();
	}
	
	/**
	 * Validates IP Addresses
	 * @return true if valid, false if not
	 */
	public boolean validate_ip() {
		Boolean ok = true;
		int num;
		// test all numbers
		num = ((Number)jFTF_IP1.getValue()).intValue();
		ok = ((num > 0) && (num < 255));
		if (ok) {
			num = ((Number)jFTF_IP2.getValue()).intValue();
			ok = ((num >= 0) && (num < 255));
		}
		if (ok) {
			num = ((Number)jFTF_IP3.getValue()).intValue();
			ok = ((num >= 0) && (num < 255));
		}
		if (ok) {
			num = ((Number)jFTF_IP4.getValue()).intValue();
			ok = ((num > 0) && (num < 255));
		}
		return ok;
	}
	
}
