package org.vigia.client.gui.view;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import org.vigia.shared.communications.ELog;

/**
 * Frame for show logs
 * @author Daniel Hector Stolfi Rosso
 * @version 1.0 (25/11/08)
 */
@SuppressWarnings("serial")
public class Log extends JFrame {

	/**
	 * jTA: Text Area for show the log
	 */
	JTextArea jTA;
	
	/**
	 * Frame for see logs
	 * @param title Title of the frame
	 */
	public Log(String title) {
		super(title);
		setSize(400, 300); 
		setLocationRelativeTo(null);
		setLayout(new BorderLayout());
        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setResizable(true);
		
        jTA = new JTextArea();
        jTA.setEditable(false);
        jTA.setVisible(true);
        JScrollPane jSP = new JScrollPane(jTA);
        jSP.setPreferredSize(new Dimension(getWidth(),50));
        add(jSP,BorderLayout.CENTER);
	}

	/**
	 * Appends a message to the log.
	 * @param log the log's type.
	 * @param message the message.
	 */
	public void appendLog(ELog log, String message) {
		jTA.append("["+new SimpleDateFormat("MMM dd H:mm:ss").format(new Date())+"] ");
		jTA.append(log.name() + " - " + message + "\n");
		
	}
	

}
