
package org.vigia.client.gui.view;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.text.NumberFormat;

import javax.swing.JFormattedTextField;
import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 * Panel for Ports
 * @author Daniel Hector Stolfi Rosso
 * @version 1.0 (25/11/08)
 */
@SuppressWarnings("serial")
public class Port extends JPanel implements PropertyChangeListener {

	/**
	 * jFTF_Port: Field for port number
	 */
	private JFormattedTextField jFTF_Port;
	/**
	 * def_port: Integer for port number
	 */
	private int def_port;
	
	/**
	 * Constructor for Port Panel
	 * @param label Text for the label
	 */	
	public Port (String label) {
		setSize(260,30);
		setLayout(null);
		setBorder(null);
		
        // label
        JLabel jL = new JLabel(label);
        add(jL);
        jL.setBounds(10, 5, 100, 20);
        
 		// formattedtextfield        
    	jFTF_Port = new JFormattedTextField(NumberFormat.getIntegerInstance());
    	jFTF_Port.addPropertyChangeListener("value", this);
        add(jFTF_Port);
        jFTF_Port.setBounds(120, 5, 135, 20);
        
        setValue(0);
	}
	
	/**
	 * Sets the values for the field
	 * @param def_Port Port value 
	 */
	public void setValue(int def_Port) {
		def_port = def_Port;
		jFTF_Port.setValue(def_port);
	}
	
	/**
	 * Validates port field
	 * @param evt field to validate
	 */
	public void propertyChange(PropertyChangeEvent evt) {
		int num = ((Number)jFTF_Port.getValue()).intValue();
        if ((num < 1) || (num > 65535)) jFTF_Port.setValue(def_port);  	
	}
		
	/**
	 * Gets Port value
	 * @return Port value
	 */
	public int getPort() {
		return ((Number)jFTF_Port.getValue()).intValue();
	}
	

}
