/**
 * 
 */
package org.vigia.client.gui.view;

import java.awt.Frame;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JTextField;

/**
 * Dialog for select the ScreenShotURL.
 * @author Daniel Hector Stolfi Rosso
 * @version 1.0 (25/11/08)
 */
@SuppressWarnings("serial")
public class ScreenShot extends JDialog {

	/**
	 * jTF_Url: File for screen shot directory
	 */
	private JTextField jTF_Url;
	/**
	 * jFc: File Chooser for choose the directory
	 */
	private final JFileChooser jFc;
	
	/**
	 * Constructor for the Screenshot Dialog
	 * @param owner JFrame's Parent
	 * @param dir Default path for the screenshot
	 * @param ctr ActionListener in Controller
	 * @param ActCmdOk Constant for Controller
	 * @param ActCmdCancel Constant for Controller
	 */
	public ScreenShot(Frame owner, String dir, ActionListener ctr, String ActCmdOk, String ActCmdCancel) {
		super(owner,"Captura de Pantalla");
		setSize(450, 155);
		setLayout(null);
        setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
        setLocationRelativeTo(owner);                
        setModal(true);
        setResizable(false);
        
        // Label
        JLabel jL = new JLabel("Ruta de la Imagen");
        add(jL);
        jL.setBounds(10, 10, 200, 30);
        
        // Text
        jTF_Url = new JTextField();
        add(jTF_Url);
        jTF_Url.setBounds(10,40,395,30);
        jTF_Url.setEditable(false);
        jTF_Url.setText(dir);
       
    	// Create a file chooser
    	jFc = new JFileChooser(dir);
    	jFc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
    	
        // Explore Button
        JButton jB_Explore = new JButton("...");
		jB_Explore.addActionListener(new java.awt.event.ActionListener() {
		    public void actionPerformed(java.awt.event.ActionEvent evt) {
		    	int returnVal = showOpDialog();
		    	if (returnVal == JFileChooser.APPROVE_OPTION) {
		    		jTF_Url.setText(jFc.getSelectedFile().getPath());
		    	}
		    }
		});
		add(jB_Explore);
		jB_Explore.setBounds(410, 40, 20, 30);
       
		// Cancel Button 
		JButton jB_Cancel = new JButton("Cancelar");
		jB_Cancel.addActionListener(ctr);
		jB_Cancel.setActionCommand(ActCmdCancel);
		add(jB_Cancel);
		jB_Cancel.setBounds(330, 90, 100, 30);	       

		// Ok Button
		JButton jB_Ok = new JButton("OK");
		jB_Ok.addActionListener(ctr);
		jB_Ok.setActionCommand(ActCmdOk);
		add(jB_Ok);
		jB_Ok.setBounds(225, 90, 100, 30);	       
       
	}

	/**
	 * Shows the open dialog
	 * @return Option selected
	 */
	private int showOpDialog() {
		 return jFc.showDialog(this,"Directorio de destino");
	}
	
	/**
	 * Gets then selected dir
	 * @return Selected dir
	 */
	public String getSelectedDir() {
		return jTF_Url.getText();
	}
}
