package org.vigia.server.communications;

/**
 * A listener to obtain control messages from the client.
 * 
 * @author jrios
 */
public interface CommandListener {
	/**
	 * Receives a move command from the client.
	 * 
	 * @param pan pan position.
	 * @param tilt tilt position.
	 * @param zoom zoom position.
	 */
	public void onMove(int pan, int tilt, int zoom);
	
	/**
	 * Initializes the camera and starts the video streaming to the client.
	 * 
	 * @param clientPort The client's port.
	 */
	public void onInit(int clientPort);
	
	/**
	 * Close the video streaming.
	 */
	public void onClose();
}
