package org.vigia.server.driver.camera;

import org.vigia.server.communications.CommandListener;

/**
 * An implementation of the CommandListener for the camera.
 * @author jrios & jesus
 */
public class CameraCommandListener implements CommandListener {

	/**
	 * The camera's driver.
	 */
	protected Driver driver;
	
	/**
	 * Creates a new CameraCommandListener.
	 * @param driver The camera's driver.
	 */
	public CameraCommandListener(Driver driver) {
		this.driver = driver;
	}
	
	/**
	 * @see org.vigia.server.communications.CommandListener#onInit(int)
	 */
	public void onInit(int clientPort) {
		driver.start();
	}

	/**
	 * @see org.vigia.server.communications.CommandListener#onMove(int, int, int)
	 */
	public void onMove(int pan, int tilt, int zoom) {
		driver.move(pan, tilt, zoom);
	}

	/**
	 * @see org.vigia.server.communications.CommandListener#onClose()
	 */
	public void onClose() {
		driver.stop();
	}
}
