package org.vigia.server.driver.camera;

import java.io.*;
import java.net.Socket;
import java.net.UnknownHostException;

/**
 * @author jesus
 *
 */
public class HttpClient 
{
	/**
	 * 
	 */
	private String m_Server;
	/**
	 * 
	 */
	private int m_Port;
	
	/**
	 * HttpClient class constructor
	 * @param server server IP address/hostname 
	 * @param port server HTTP port 
	 */
    public HttpClient(String server, int port)
    {
        this.m_Server = server;
        this.m_Port = port;
    }

    /**
     * 
     * @param s server action 
	 * @param s1 server command 
	 * @param flag true=POST request / false=GET request
	 * @return HTTP server response
     */
    public String REQUEST(String s, String s1, boolean flag)
    {
        try
        {
            Socket socket = new Socket(this.m_Server, this.m_Port);
            BufferedInputStream bufferedinputstream = new BufferedInputStream(socket.getInputStream());
            BufferedOutputStream bufferedoutputstream = new BufferedOutputStream(socket.getOutputStream());
            String s2 = "";
            if(flag)
            {
                s2 = (new StringBuilder()).append("POST ").append(s).append(" HTTP/1.0\r\n").toString();
                s2 = (new StringBuilder()).append(s2).append("User-Agent: TrackerCamHttp/1.0\r\nAccept: www/source; text/html; image/gif; */*\r\n").toString();
                s2 = (new StringBuilder()).append(s2).append("Content-type:application/x-www-form-urlencoded\r\n").toString();
                s2 = (new StringBuilder()).append(s2).append("Content-length: ").append(s1.length()).append("\r\n\r\n").toString();
                s2 = (new StringBuilder()).append(s2).append(s1).append("\r\n").toString();
            } else
            {
                s2 = (new StringBuilder()).append("GET ").append(s1).append(" HTTP/1.0\r\n\r\n").toString();
            }
            bufferedoutputstream.write(s2.getBytes(), 0, s2.length());
            bufferedoutputstream.flush();
            String s3;
            int i;
            for(s3 = ""; (i = bufferedinputstream.read()) != -1; s3 = (new StringBuilder()).append(s3).append((char)i).toString());
            socket.close();
            bufferedinputstream.close();
            bufferedoutputstream.close();
            return s3;
        }
        catch(UnknownHostException unknownhostexception)
        {
            return "failed";
        }
        catch(IOException ioexception)
        {
            return "failed";
        }
    }

}