package org.vigia.test;

import org.vigia.server.driver.camera.*;
import java.io.*;

/**
 * @author jesus
 *
 */
public class CameraDriverTest {

	/**
	 * @param args Program's arguments
	 */
	public static void main(String[] args) {
		//create CameraDriver object, connected to localhost on port 8090
		CameraDriver camdriver = new CameraDriver();  //alternative constructor -> CameraDriver("127.0.0.1", 8090);
		
		//test mode (1->auto, 2->manual)
		String mode = null;
		
		//BufferedReader for standard input
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		
		try {
			System.out.println("Auto/Manual Test: ");
			mode = br.readLine();
			if (!(mode.equals("Auto") || mode.equals("Manual")))
			{
				System.out.println("Error: bad test mode.");
			}
		}catch (IOException e){
			System.out.println("Error while getting test mode:"+e.getMessage());
		}
		
		if (mode.equals("Auto")){
			//-------------------- Camera Auto Test -------------------------
			
			try {
			
			//move camera to home position; no digital zoom (100%)
			camdriver.goHome();
			Thread.sleep(1000);
			
			//move camera to absolute position (50,0); no digital zoom (100%) 
			camdriver.move(50, 0, 100);
			Thread.sleep(1000);
			
			//move camera to absolute position (-90,0); no digital zoom (100%) 
			camdriver.move(-40, 0, 100);
			Thread.sleep(1000);
			
			//move camera to absolute position (0,20); no digital zoom (100%) 
			camdriver.move(0, 20, 100);
			Thread.sleep(1000);
			
			//move camera to absolute position (0,-50); no digital zoom (100%) 
			camdriver.move(0, -30, 100);
			Thread.sleep(1000);
			
			//move camera to home position; no digital zoom (100%)
			camdriver.goHome();

			}catch (InterruptedException e){
				System.out.println("Error while camera auto testing: "+e.getMessage());
			}
			
		}else if (mode.equals("Manual")){
			
			//-------------------- Camera Manual Test -------------------------
			try {
				for (int j=0;j<5;j++){
					System.out.println("Value of Pan:");
					int pan = Integer.parseInt(br.readLine());
					System.out.println("Value of Tilt:");
					int tilt = Integer.parseInt(br.readLine());
					System.out.println("Value of Zoom:");
					int zoom = Integer.parseInt(br.readLine());
					
					camdriver.move(pan, tilt, zoom);
				}
			}catch (IOException e){
				System.out.println("Error while camera manual testing: "+e.getMessage());
			}
		}	
	}

	
}
