package org.vigia.test;

import java.awt.image.BufferedImage;
import java.io.IOException;
import java.net.UnknownHostException;

import org.vigia.client.communications.RemoteCameraCommunicator;
import org.vigia.shared.communications.ELog;
import org.vigia.shared.communications.FrameListener;
import org.vigia.shared.communications.LogListener;

/**
 * A dummy client.
 * @author jrios
 */
public class CommunicationsClientTest {
	/**
	 * Number of frames received.
	 */
	protected static int frames=0;
	
	/**
	 * The last Image.
	 */
	protected static BufferedImage image;
	/**
	 * The main function.
	 * @param args The arguments.
	 * @throws IOException IOException.
	 * @throws UnknownHostException UnknownHostException.
	 * @throws InterruptedException InterruptedException.
	 */
	public static void main(String[] args) throws UnknownHostException, IOException, InterruptedException {
		RemoteCameraCommunicator rcc = new RemoteCameraCommunicator("localhost",48002,48002);
		
		rcc.addLogListener(new LogListener(){
			public void onLog(ELog log, String message) {
				System.out.println(">"+log.name()+": "+message);
			}});
		
		rcc.addFrameListener(new FrameListener(){
			public void onNewFrame(BufferedImage frame) {
				frames++;
			}});
		
		int i=0;
		long time = System.currentTimeMillis()+1000*10;
		while(System.currentTimeMillis()<time){
			rcc.move(i, i, i);
			i=(i+1)%50;
			Thread.sleep(1000);
		}
		
		rcc.close();
		
		System.out.println("I have received "+frames+" frames.");
	}
}
