package org.vigia.test;

import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;

import org.vigia.server.communications.ClientCommunicator;
import org.vigia.server.communications.CommandListener;
import org.vigia.shared.communications.ELog;

/**
 * A dummy server.
 * @author jrios
 */
public class CommunicationsServerTest {
	/**
	 * Send frames?
	 */
	protected static boolean send = false;
	/**
	 * The main function.
	 * @param args The arguments.
	 * @throws IOException IOException
	 */
	public static void main(String[] args) throws IOException {
		final ClientCommunicator cc = new ClientCommunicator(1234);
		cc.addCommandListener(new CommandListener(){
			public void onInit(int clientPort) {
				System.out.println("Initializing...");
				send=true;
				try {
					cc.sendLog(ELog.Info, "Initialized.");
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			public void onMove(int pan, int tilt, int zoom) {
				System.out.println("Moving to ("+pan+","+tilt+","+zoom+")...");
				try {
					cc.sendLog(ELog.Info, "Moved to ("+pan+","+tilt+","+zoom+").");
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			public void onClose() {
				send=false;
			}});
		
		BufferedImage image1 = ImageIO.read(new File("image1.jpg"));
		BufferedImage image2 = ImageIO.read(new File("image2.jpg"));
		
		while(true){
			if(send){
				cc.sendFrame(image1);
				cc.sendFrame(image2);
				System.out.println(".");
			}
		}
	}
}
