package org.vigia.test;

import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import javax.imageio.ImageIO;

import org.vigia.server.driver.util.ImageUtil;

/**
 * @author Israelem
 *
 */
public class ImageTest {
	
	/**
	 * @param args The default arguments
	 * @throws IOException Error al leer la imagen
	 */
	public static void main(String[] args) throws IOException{
		
		BufferedImage i;
		
		/**
		 * Se realizan las siguientes pruebas:
		 * 1.- Se recorta desde la esquina superior izquierda
		 * 2.- Se recorta desde la esquina superior derecha
		 * 3.- Se recorta desde la esquina inferior izquierda
		 * 4.- Se recorta desde la esquina inferior derecha
		 * 5.- Se recorta una una zona central
		 */
		i = ImageIO.read(new File("image1.jpg"));
		i = ImageUtil.crop(i, 0, 0, 700, 500);
		ImageIO.write(i, "jpg", new File("image1recortada1.jpg"));
		
		i = ImageIO.read(new File("image1.jpg"));
		i = ImageUtil.crop(i, 200, 0, 600, 200);
		ImageIO.write(i, "jpg", new File("image1recortada2.jpg"));
		
		i = ImageIO.read(new File("image1.jpg"));
		i = ImageUtil.crop(i, 0, 300, 500, 300);
		ImageIO.write(i, "jpg", new File("image1recortada3.jpg"));
		
		i = ImageIO.read(new File("image1.jpg"));
		i = ImageUtil.crop(i, 400, 300, 400, 300);
		ImageIO.write(i, "jpg", new File("image1recortada4.jpg"));
		
		i = ImageIO.read(new File("image1.jpg"));
		i = ImageUtil.crop(i, 100, 100, 500, 300);
		ImageIO.write(i, "jpg", new File("image1recortada5.jpg"));
	}
}
