package org.vigia.test;

import org.vigia.client.driver.Coordinates;
import org.vigia.client.driver.IRListener;
import org.vigia.client.driver.PTZ;
import org.vigia.client.driver.util.MovementProcessor;

/**
 * Printer of the remote camera's calculated movement.
 * @author Ada
 */
public class MovementPrinter implements IRListener{
	
	/**
	 * The movement processor.
	 */
	protected MovementProcessor mp;
	
	/**
	 * The constructor.
	 */
	public MovementPrinter(){
		mp = new MovementProcessor();
	}

	/**
	 * @see org.vigia.client.driver.IRListener#onIREvent(org.vigia.client.driver.Coordinates, int, int)
	 */
	@Override
	public void onIREvent(Coordinates c, int xVRes, int yVRes) {
		PTZ ptz = mp.calculatePTZ(c, xVRes, yVRes);
		if (ptz != null) {
			System.out.println("Mover cmara: pan = " + ptz.getPan() + " tilt = " + ptz.getTilt() + " zoom = " + ptz.getZoom());
		}
	}

}
