package org.vigia.test;

import org.vigia.client.driver.PTZ;
import org.vigia.client.driver.util.MovementProcessor;
import org.vigia.client.driver.Coordinates;

/**
 * Test for the movement processor.
 * @author Ada
 */
public class MovementProcessorTest {
	
	/**
	 * The main method.
	 * @param args not used.
	 */
	public static void main(String[] args){
		MovementProcessor mp = new MovementProcessor();
		PTZ ptz;
		int x;
		int y;
		float z;
		
		//Simulation of movement: the user is always at the same proyected
		//distance (1000) of the wiimote, and he is going down and to the right.
		//The pan will grow in absolute value (and it will be positive).
		//The tilt will fall in absolute value (and it will be negative).
		//By the moment, the zoom is always 100.
		int pn = 1;
		for (int i = 0; i <= 1000; i=i+11){
			pn=-pn;
			x = pn*i;
			y = 500 - pn*i;
			z = (float) Math.sqrt(Math.pow(y, 2) + Math.pow(1000, 2));
			Coordinates c = new Coordinates(x,y,z);
			ptz = mp.calculatePTZ(c,0,0);
			System.out.println("Move" + ptz.toString() + "  Coordenadas: ( " + x + ", " + y +" )");
		}
	}
	
}
