package org.vigia.test;

import java.awt.event.ActionEvent;
import java.awt.image.BufferedImage;

import org.vigia.client.driver.Coordinates;
import org.vigia.client.exception.VigiaClientException;
import org.vigia.client.gui.controller.Controller;
import org.vigia.client.gui.view.Panel;
import org.vigia.shared.communications.ELog;

/**
 * Testing GUI Panel Class
 * @author Daniel Hector Stolfi Rosso
 * @version 1.0 (25/11/08)
 *
 */
public class ViewTest implements Controller {
	
	/**
	 * Panel for testing
	 */
	private Panel p;
	
	/**
	 * Constructor for Testing class
	 */
	public ViewTest() {
		p = new Panel("TEST CLIENTE VIGIA","127.0.0.1","1234","4444","/home/daniel/testlog.txt","/home/daniel/Documentos");

		p.controller(this);		
		
		p.setStatusInfo("No conectado");
		p.showImage(new BufferedImage(640,480,BufferedImage.TYPE_BYTE_BINARY));		
	}
	

	/**
	 * Testing GUI
	 * @param args Useless
	 */
	public static void main(String[] args) {
		new ViewTest();				
	}

	/**
	 * Simulates controller
	 * @param e Event from View
	 */
	@SuppressWarnings("static-access")
	public void actionPerformed(ActionEvent e) {
		
		String cmd = e.getActionCommand();
		
		// Panel
		if (cmd.equals(p.ActCmdPANEL_ABOUT)) {
			p.showAboutInfo();
		} else if (cmd.equals(p.ActCmdPANEL_DISC)) {
			p.setStatusInfo("Desconectado");
		} else if (cmd.equals(p.ActCmdPANEL_CONN)) {
			p.showConnectToServerPanel();
		} else if (cmd.equals(p.ActCmdPANEL_CONFIG)) {
			p.showAdvancedConnectionSettingsPanel();
		} else if (cmd.equals(p.ActCmdPANEL_SCRSHOT)) {
			p.showGetScreenShotPanel();
		} else if (cmd.equals(p.ActCmdPANEL_SHOWLOG)) {
			p.showLog();
		} else if (cmd.equals(p.ActCmdPANEL_CLOSE)) {
			p.setVisible(false);
			System.exit(0);
		// Connect
		} else if (cmd.equals(p.ActCmdCONN_ADVOPC)) {
			p.showAdvancedConnectionSettingsPanel();
		} else if (cmd.equals(p.ActCmdCONN_OK)) {
			System.out.println(p.getIPServer());
			System.out.println(p.getDataPort());
			System.out.println(p.getControlPort());
			p.closeConnectToServerPanel();
			p.setStatusInfo("Conectado: "+p.getIPServer()+":"+p.getDataPort()+":"+p.getControlPort());
		} else if (cmd.equals(p.ActCmdCONN_CANCEL)) {
			p.closeConnectToServerPanel();
		// Advanced Options
		} else if (cmd.equals(p.ActCmdADVOPC_OK)) {
			System.out.println(p.getIPServer());
			System.out.println(p.getDataPort());
			System.out.println(p.getControlPort());
			p.closeAdvancedConnectionSettingsPanel();
		} else if (cmd.equals(p.ActCmdADVOPC_CANCEL)) {
			p.closeAdvancedConnectionSettingsPanel();
		// screen shot
		} else if (cmd.equals(p.ActCmdSCRSHOT_OK)) {
			System.out.println(p.getScreenShotURL());
			p.closeGetScreenShotPanel();			
		} else if (cmd.equals(p.ActCmdSCRSHOT_CANCEL)) {
			p.closeGetScreenShotPanel();
		}
		
		
		
	}


	/**
	 * @see org.vigia.shared.communications.FrameListener#onNewFrame(java.awt.image.BufferedImage)
	 */
	@Override
	public void onNewFrame(BufferedImage frame) {
		// TODO Auto-generated method stub
		
	}



	/**
	 * @see org.vigia.client.driver.IRListener#onIREvent(org.vigia.client.driver.Coordinates, int, int)
	 */
	public void onIREvent(Coordinates c, int xVRes, int yVRes) throws VigiaClientException {
		// TODO Auto-generated method stub
		
	}


	/**
	 * @see org.vigia.shared.communications.LogListener#onLog(org.vigia.shared.communications.ELog, java.lang.String)
	 */
	public void onLog(ELog log, String message) {
		// TODO Auto-generated method stub
		
	}
	
}
